<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ReadOnlyRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">ReadOnlyRequestProcessor.java</span></div><h1>ReadOnlyRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.util.concurrent.LinkedBlockingQueue;

import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.ZooKeeperCriticalThread;
import org.apache.zookeeper.server.ZooKeeperServer;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.server.quorum.Leader.XidRolloverException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This processor is at the beginning of the ReadOnlyZooKeeperServer's
 * processors chain. All it does is, it passes read-only operations (e.g.
 * OpCode.getData, OpCode.exists) through to the next processor, but drops
 * state-changing operations (e.g. OpCode.create, OpCode.setData).
 */
public class ReadOnlyRequestProcessor extends ZooKeeperCriticalThread implements RequestProcessor {

<span class="fc" id="L44">    private static final Logger LOG = LoggerFactory.getLogger(ReadOnlyRequestProcessor.class);</span>

<span class="fc" id="L46">    private LinkedBlockingQueue&lt;Request&gt; queuedRequests = new LinkedBlockingQueue&lt;Request&gt;();</span>

<span class="fc" id="L48">    private boolean finished = false;</span>

    private RequestProcessor nextProcessor;

    private ZooKeeperServer zks;

    public ReadOnlyRequestProcessor(ZooKeeperServer zks,
            RequestProcessor nextProcessor) {
<span class="fc" id="L56">        super(&quot;ReadOnlyRequestProcessor:&quot; + zks.getServerId(), zks</span>
<span class="fc" id="L57">                .getZooKeeperServerListener());</span>
<span class="fc" id="L58">        this.zks = zks;</span>
<span class="fc" id="L59">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L60">    }</span>

    public void run() {
        try {
<span class="pc bpc" id="L64" title="1 of 2 branches missed.">            while (!finished) {</span>
<span class="fc" id="L65">                Request request = queuedRequests.take();</span>

                // log request
<span class="fc" id="L68">                long traceMask = ZooTrace.CLIENT_REQUEST_TRACE_MASK;</span>
<span class="pc bpc" id="L69" title="1 of 2 branches missed.">                if (request.type == OpCode.ping) {</span>
<span class="nc" id="L70">                    traceMask = ZooTrace.CLIENT_PING_TRACE_MASK;</span>
                }
<span class="pc bpc" id="L72" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L73">                    ZooTrace.logRequest(LOG, traceMask, 'R', request, &quot;&quot;);</span>
                }
<span class="fc bfc" id="L75" title="All 2 branches covered.">                if (Request.requestOfDeath == request) {</span>
<span class="fc" id="L76">                    break;</span>
                }

                // filter read requests
<span class="fc bfc" id="L80" title="All 2 branches covered.">                switch (request.type) {</span>
                case OpCode.sync:
                case OpCode.create:
                case OpCode.delete:
                case OpCode.setData:
                case OpCode.setACL:
                case OpCode.multi:
                case OpCode.check:
<span class="fc" id="L88">                    ReplyHeader hdr = new ReplyHeader(request.cxid, zks.getZKDatabase()</span>
<span class="fc" id="L89">                            .getDataTreeLastProcessedZxid(), Code.NOTREADONLY.intValue());</span>
                    try {
<span class="fc" id="L91">                        request.cnxn.sendResponse(hdr, null, null);</span>
<span class="nc" id="L92">                    } catch (IOException e) {</span>
<span class="nc" id="L93">                        LOG.error(&quot;IO exception while sending response&quot;, e);</span>
<span class="fc" id="L94">                    }</span>
<span class="nc" id="L95">                    continue;</span>
                }

                // proceed to the next processor
<span class="pc bpc" id="L99" title="1 of 2 branches missed.">                if (nextProcessor != null) {</span>
<span class="fc" id="L100">                    nextProcessor.processRequest(request);</span>
                }
<span class="fc" id="L102">            }</span>
<span class="nc" id="L103">        } catch (RequestProcessorException e) {</span>
<span class="nc bnc" id="L104" title="All 2 branches missed.">            if (e.getCause() instanceof XidRolloverException) {</span>
<span class="nc" id="L105">                LOG.info(e.getCause().getMessage());</span>
            }
<span class="nc" id="L107">            handleException(this.getName(), e);</span>
<span class="nc" id="L108">        } catch (Exception e) {</span>
<span class="nc" id="L109">            handleException(this.getName(), e);</span>
<span class="pc" id="L110">        }</span>
<span class="fc" id="L111">        LOG.info(&quot;ReadOnlyRequestProcessor exited loop!&quot;);</span>
<span class="fc" id="L112">    }</span>

    @Override
    public void processRequest(Request request) {
<span class="pc bpc" id="L116" title="1 of 2 branches missed.">        if (!finished) {</span>
<span class="fc" id="L117">            queuedRequests.add(request);</span>
        }
<span class="fc" id="L119">    }</span>

    @Override
    public void shutdown() {
<span class="fc" id="L123">        finished = true;</span>
<span class="fc" id="L124">        queuedRequests.clear();</span>
<span class="fc" id="L125">        queuedRequests.add(Request.requestOfDeath);</span>
<span class="fc" id="L126">        nextProcessor.shutdown();</span>
<span class="fc" id="L127">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>